<template>
  <div id="app">
     <h1>Stefan shopping cart</h1> 

        <to-do-form @todo-added="addToDo"></to-do-form>
      <table>
        <tr>
          <th>Product Name</th>
          <th>Product Price</th>
          <th>Stock</th>
          <th>Order</th>
          </tr>
        <template v-for="task in ToDoItems" >
              <to-do-item v-bind:key="task.id" :label="task.label" 
                    :done="task.done" 
                    :id="task.id"
                    :price="task.price"
                    :quantity="task.quantity"
                    :stock="task.stock"
                    @checkbox-changed="updateDoneStatus(task.id)"
                    @quantity-changed="quantityChanged(task.id,$event)"
                    @item-deleted="deleteToDo(task.id)"
                    @item-edited="editToDo(task.id, $event)">
                    </to-do-item>
       </template >
      </table>
    


    <h2 id="list-summary">{{listSummary}}</h2>

  </div>
</template>

<script>
//import HelloWorld from './components/HelloWorld.vue'
import ToDoItem from './components/ToDoItem.vue'
import uniqueId from 'lodash.uniqueid'

import ToDoForm from './components/ToDoForm.vue'

export default {
  name: 'App',
  components: {
    ToDoItem,
    ToDoForm
  },

  data(){
    return {
      ToDoItems: [
        { id: uniqueId('todo-'), label: 'Coca-cola', price: 50, done: false, quantity: 0, stock:20 },
        { id: uniqueId('todo-'), label: 'Bread', price: 30, done: false, quantity: 0 ,stock:30 },
        { id: uniqueId('todo-'), label: 'Beer', price: 55, done: false, quantity: 0, stock : 22 },
        { id: uniqueId('todo-'), label: 'Chips', price: 110, done: false, quantity: 0, stock  : 55 }
      ]
    }
  },
  methods:{
    addToDo(toDoLabel, toDoPrice, stockD){
      let newToDo = {
        id:uniqueId('todo-', ),
        label: toDoLabel,
        done: false,
        price: toDoPrice,
        stock: stockD
        };
        this.ToDoItems.push(newToDo);
    },
    quantityChanged(id,newQuantity)
    {
      const toDoToUpdate = this.ToDoItems.find(item => item.id === id)
      toDoToUpdate.quantity = newQuantity
    },
    updateDoneStatus(toDoId) {
      const toDoToUpdate = this.ToDoItems.find(item => item.id === toDoId)
      toDoToUpdate.done = !toDoToUpdate.done
      if(toDoToUpdate.done==true)
      {
        toDoToUpdate.stock = toDoToUpdate.stock - toDoToUpdate.quantity;
      }
      else{
         toDoToUpdate.stock = eval(toDoToUpdate.stock) + eval(toDoToUpdate.quantity);
      }
    },
    deleteToDo(toDoId) {
      const itemIndex = this.ToDoItems.findIndex(item => item.id === toDoId);
      this.ToDoItems.splice(itemIndex, 1);
    },
    editToDo(toDoId, newLabel,newPrice) {
      const toDoToEdit = this.ToDoItems.find(item => item.id === toDoId);
      toDoToEdit.label = newLabel;
      toDoToEdit.price = newPrice;
    }
  },
  computed:{
    listSummary() {
      const vkupnaSuma = this.ToDoItems.filter(item =>item.done).reduce((a, b) => a + b.price*b.quantity, 0)
      return `Total price for selected objects ${vkupnaSuma}`
    }
  }
}
</script>

<style>
/* Global styles */
#list-summary{
  float: right;
margin-right: 430px !important;
font-size:25px;
}
.checkbox{
  height: 25px;
width: 20px;
}
table {
  border-collapse: collapse;
}
 table tr, table{
  border: 1px solid black !important;
}
th, td {
    padding-left: 60px;
    font-size: 25px;
}
.lastTd{
  padding-left: 0px !important;
}
.btn {
  padding: 0.8rem 1rem 0.7rem;
  border: 0.2rem solid #4d4d4d;
  cursor: pointer;
  text-transform: capitalize;
}
.btn__danger {
  color: #fff;
  background-color: #ca3c3c;
  border-color: #bd2130;
}
.btn__filter {
  border-color: lightgrey;
}
.btn__danger:focus {
  outline-color: #c82333;
}
.btn__primary {
  color: #fff;
  background-color: #000;
}
.btn-group {
  display: flex;
  justify-content: space-between;
}
.btn-group > * {
  flex: 1 1 auto;
}
.btn-group > * + * {
  margin-left: 0.8rem;
}
.label-wrapper {
  margin: 0;
  flex: 0 0 100%;
  text-align: center;
}
[class*="__lg"] {
  display: inline-block;
  width: 100%;
  font-size: 1.9rem;
}
[class*="__lg"]:not(:last-child) {
  margin-bottom: 1rem;
}
@media screen and (min-width: 620px) {
  [class*="__lg"] {
    font-size: 2.4rem;
  }
}
.visually-hidden {
  position: absolute;
  height: 1px;
  width: 1px;
  overflow: hidden;
  clip: rect(1px 1px 1px 1px);
  clip: rect(1px, 1px, 1px, 1px);
  clip-path: rect(1px, 1px, 1px, 1px);
  white-space: nowrap;
}
[class*="stack"] > * {
  margin-top: 0;
  margin-bottom: 0;
}
.stack-small > * + * {
  margin-top: 1.25rem;
}
.stack-large > * + * {
  margin-top: 2.5rem;
}
@media screen and (min-width: 550px) {
  .stack-small > * + * {
    margin-top: 1.4rem;
  }
  .stack-large > * + * {
    margin-top: 2.8rem;
  }
}
/* End global styles */
#app {
  background: #fff;
  margin: 2rem 0 4rem 0;
  padding: 1rem;
  padding-top: 0;
  position: relative;
  box-shadow: 0 2px 4px 0 rgba(0, 0, 0, 0.2), 0 2.5rem 5rem 0 rgba(0, 0, 0, 0.1);
}
@media screen and (min-width: 550px) {
  #app {
    padding: 4rem;
  }
}
#app > * {
  max-width: 50rem;
  margin-left: auto;
  margin-right: auto;
}
#app > form {
  max-width: 100%;
}
#app h1 {
  display: block;
  min-width: 100%;
  width: 100%;
  text-align: center;
  margin: 0;
  margin-bottom: 1rem;
}
</style>
